Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/MctsContextualSampler.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/MctsContextualSampler.cs	(revision 11742)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/MctsContextualSampler.cs	(revision 11742)
@@ -0,0 +1,187 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Diagnostics;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Algorithms.Bandits;
+using HeuristicLab.Problems.GrammaticalOptimization;
+
+namespace HeuristicLab.Algorithms.GrammaticalOptimization {
+  public class MctsContextualSampler {
+    private class TreeNode {
+      public int randomTries;
+      public int policyTries;
+      public TreeNode[] children;
+      public readonly ReadonlySequence phrase;
+      public readonly ReadonlySequence alt;
+
+      // phrase represents the phrase of the state and alt represents how the phrase has been reached from the parent state
+      public TreeNode(ReadonlySequence phrase, ReadonlySequence alt) {
+        this.phrase = phrase;
+        this.alt = alt;
+      }
+
+      public override string ToString() {
+        return string.Format("Node({0} tries: {1})", phrase, randomTries + policyTries);
+      }
+    }
+
+
+    public event Action<string, double> FoundNewBestSolution;
+    public event Action<string, double> SolutionEvaluated;
+
+    private readonly int maxLen;
+    private readonly IProblem problem;
+    private readonly Random random;
+    private readonly int randomTries;
+    private readonly IGrammarPolicy policy;
+
+    private List<Tuple<ReadonlySequence, ReadonlySequence, ReadonlySequence>> updateChain;
+    private TreeNode rootNode;
+
+    public int treeDepth;
+    public int treeSize;
+
+    // public MctsSampler(IProblem problem, int maxLen, Random random) :
+    //   this(problem, maxLen, random, 10, (rand, numActions) => new EpsGreedyPolicy(rand, numActions, 0.1)) {
+    // 
+    // }
+
+    public MctsContextualSampler(IProblem problem, int maxLen, Random random, int randomTries, IGrammarPolicy policy) {
+      this.maxLen = maxLen;
+      this.problem = problem;
+      this.random = random;
+      this.randomTries = randomTries;
+      this.policy = policy;
+    }
+
+    public void Run(int maxIterations) {
+      double bestQuality = double.MinValue;
+      InitPolicies(problem.Grammar);
+      for (int i = 0; !policy.Done(rootNode.phrase) && i < maxIterations; i++) {
+        var sentence = SampleSentence(problem.Grammar).ToString();
+        var quality = problem.Evaluate(sentence) / problem.BestKnownQuality(maxLen);
+        Debug.Assert(quality >= 0 && quality <= 1.0);
+        DistributeReward(quality);
+
+        RaiseSolutionEvaluated(sentence, quality);
+
+        if (quality > bestQuality) {
+          bestQuality = quality;
+          RaiseFoundNewBestSolution(sentence, quality);
+        }
+      }
+
+      // clean up
+      InitPolicies(problem.Grammar); GC.Collect();
+    }
+
+    public void PrintStats() {
+      var n = rootNode;
+      Console.WriteLine("depth: {0,5} size: {1,10} root tries {2,10}", treeDepth, treeSize, rootNode.policyTries + rootNode.randomTries);
+      while (n.children != null) {
+        Console.WriteLine();
+        Console.WriteLine("{0,5}->{1,-50}", n.alt, string.Join(" ", n.children.Select(ch => string.Format("{0,4}", ch.alt))));
+        Console.WriteLine("{0,5}  {1,-50}", string.Empty, string.Join(" ", n.children.Select(ch => string.Format("{0,4}", ch.randomTries + ch.policyTries))));
+        //n.policy.PrintStats();
+        n = n.children.OrderByDescending(c => c.policyTries).First();
+      }
+      Console.ReadLine();
+    }
+
+    private void InitPolicies(IGrammar grammar) {
+      this.updateChain = new List<Tuple<ReadonlySequence, ReadonlySequence, ReadonlySequence>>();
+
+      rootNode = new TreeNode(new ReadonlySequence(grammar.SentenceSymbol), new ReadonlySequence("$"));
+      treeDepth = 0;
+      treeSize = 0;
+    }
+
+    private Sequence SampleSentence(IGrammar grammar) {
+      updateChain.Clear();
+      var startPhrase = new Sequence(rootNode.phrase);
+      return CompleteSentence(grammar, startPhrase);
+    }
+
+    private Sequence CompleteSentence(IGrammar g, Sequence phrase) {
+      if (phrase.Length > maxLen) throw new ArgumentException();
+      if (g.MinPhraseLength(phrase) > maxLen) throw new ArgumentException();
+      TreeNode parent = null;
+      TreeNode n = rootNode;
+      bool done = false;
+      var curDepth = 0;
+      while (!done) {
+        if (parent != null)
+          updateChain.Add(Tuple.Create(parent.phrase, n.alt, n.phrase));
+
+        if (n.randomTries < randomTries) {
+          n.randomTries++;
+          treeDepth = Math.Max(treeDepth, curDepth);
+          return g.CompleteSentenceRandomly(random, phrase, maxLen);
+        } else {
+          char nt = phrase.FirstNonTerminal;
+
+          int maxLenOfReplacement = maxLen - (phrase.Length - 1); // replacing aAb with maxLen 4 means we can only use alternatives with a minPhraseLen <= 2
+          Debug.Assert(maxLenOfReplacement > 0);
+
+          var alts = g.GetAlternatives(nt).Where(alt => g.MinPhraseLength(alt) <= maxLenOfReplacement);
+
+          if (n.randomTries == randomTries && n.children == null) {
+            n.children = new TreeNode[alts.Count()];
+            int cIdx = 0;
+            foreach (var alt in alts) {
+              var newPhrase = new Sequence(phrase);
+              newPhrase.ReplaceAt(phrase.FirstNonTerminalIndex, 1, alt);
+              n.children[cIdx++] = new TreeNode(new ReadonlySequence(newPhrase), new ReadonlySequence(alt));
+            }
+            treeSize += n.children.Length;
+          }
+
+          n.policyTries++;
+          // => select using bandit policy
+          ReadonlySequence selectedAlt = policy.SelectAction(random, n.phrase, n.children.Select(c => c.alt));
+
+          // replace nt with alt
+          phrase.ReplaceAt(phrase.FirstNonTerminalIndex, 1, selectedAlt);
+
+          curDepth++;
+
+          done = phrase.IsTerminal;
+
+          // prepare for next iteration
+          parent = n;
+          n = n.children.Single(ch => ch.alt == selectedAlt); // TODO: perf
+        }
+      } // while
+
+      n.policyTries++;
+      updateChain.Add(Tuple.Create(parent.phrase, n.alt, n.phrase));
+
+
+      treeDepth = Math.Max(treeDepth, curDepth);
+      return phrase;
+    }
+
+    private void DistributeReward(double reward) {
+      // iterate in reverse order (bottom up)
+      updateChain.Reverse();
+
+      foreach (var e in updateChain) {
+        var state = e.Item1;
+        var action = e.Item2;
+        var newState = e.Item3;
+        policy.UpdateReward(state, action, reward, newState);
+        //policy.UpdateReward(action, reward / updateChain.Count);
+      }
+    }
+
+    private void RaiseSolutionEvaluated(string sentence, double quality) {
+      var handler = SolutionEvaluated;
+      if (handler != null) handler(sentence, quality);
+    }
+    private void RaiseFoundNewBestSolution(string sentence, double quality) {
+      var handler = FoundNewBestSolution;
+      if (handler != null) handler(sentence, quality);
+    }
+  }
+}
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/MctsSampler.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/MctsSampler.cs	(revision 11741)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Algorithms.GrammaticalOptimization/MctsSampler.cs	(revision 11742)
@@ -12,6 +12,5 @@
       public string ident;
       public int randomTries;
-      public int policyTries;
-      public IPolicyActionInfo actionInfo;
+      public IBanditPolicyActionInfo actionInfo;
       public TreeNode[] children;
       public bool done = false;
@@ -22,5 +21,5 @@
 
       public override string ToString() {
-        return string.Format("Node({0} tries: {1}, done: {2}, policy: {3})", ident, randomTries + policyTries, done, actionInfo);
+        return string.Format("Node({0} tries: {1}, done: {2}, policy: {3})", ident, actionInfo.Tries, done, actionInfo);
       }
     }
@@ -34,5 +33,5 @@
     private readonly Random random;
     private readonly int randomTries;
-    private readonly IPolicy policy;
+    private readonly IBanditPolicy policy;
 
     private List<TreeNode> updateChain;
@@ -47,5 +46,5 @@
     // }
 
-    public MctsSampler(IProblem problem, int maxLen, Random random, int randomTries, IPolicy policy) {
+    public MctsSampler(IProblem problem, int maxLen, Random random, int randomTries, IBanditPolicy policy) {
       this.maxLen = maxLen;
       this.problem = problem;
@@ -78,11 +77,12 @@
     public void PrintStats() {
       var n = rootNode;
-      Console.WriteLine("depth: {0,5} size: {1,10} root tries {2,10}", treeDepth, treeSize, rootNode.policyTries + rootNode.randomTries);
+      Console.WriteLine("depth: {0,5} size: {1,10} root tries {2,10}", treeDepth, treeSize, n.actionInfo.Tries);
       while (n.children != null) {
         Console.WriteLine();
         Console.WriteLine("{0,5}->{1,-50}", n.ident, string.Join(" ", n.children.Select(ch => string.Format("{0,4}", ch.ident))));
-        Console.WriteLine("{0,5}  {1,-50}", string.Empty, string.Join(" ", n.children.Select(ch => string.Format("{0,4}", ch.randomTries + ch.policyTries))));
+        Console.WriteLine("{0,5}  {1,-50}", string.Empty, string.Join(" ", n.children.Select(ch => string.Format("{0,4:F2}", ch.actionInfo.Value * 10))));
+        Console.WriteLine("{0,5}  {1,-50}", string.Empty, string.Join(" ", n.children.Select(ch => string.Format("{0,4}", ch.done ? "X" : ch.actionInfo.Tries.ToString()))));
         //n.policy.PrintStats();
-        n = n.children.OrderByDescending(c => c.policyTries).First();
+        n = n.children.Where(ch => !ch.done).OrderByDescending(c => c.actionInfo.Value).First();
       }
       Console.ReadLine();
@@ -108,7 +108,6 @@
       if (g.MinPhraseLength(phrase) > maxLen) throw new ArgumentException();
       TreeNode n = rootNode;
-      bool done = phrase.IsTerminal;
       var curDepth = 0;
-      while (!done) {
+      while (!phrase.IsTerminal) {
         updateChain.Add(n);
 
@@ -127,9 +126,7 @@
           if (n.randomTries == randomTries && n.children == null) {
             n.children = alts.Select(alt => new TreeNode(alt.ToString())).ToArray(); // create a new node for each alternative
-            //n.children = alts.Select(alt => new TreeNode(string.Empty)).ToArray(); // create a new node for each alternative
             foreach (var ch in n.children) ch.actionInfo = policy.CreateActionInfo();
             treeSize += n.children.Length;
           }
-          n.policyTries++;
           // => select using bandit policy
           int selectedAltIdx = policy.SelectAction(random, n.children.Select(c => c.actionInfo));
@@ -140,6 +137,4 @@
 
           curDepth++;
-
-          done = phrase.IsTerminal;
 
           // prepare for next iteration
@@ -153,5 +148,4 @@
       // the last node is a leaf node (sentence is done), so we never need to visit this node again
       n.done = true;
-      n.actionInfo.Disable();
 
       treeDepth = Math.Max(treeDepth, curDepth);
@@ -165,4 +159,5 @@
       foreach (var e in updateChain) {
         var node = e;
+        if (node.done) node.actionInfo.Disable();
         if (node.children != null && node.children.All(c => c.done)) {
           node.done = true;
@@ -171,5 +166,4 @@
         if (!node.done) {
           node.actionInfo.UpdateReward(reward);
-          //policy.UpdateReward(action, reward / updateChain.Count);
         }
       }
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Common/Extensions.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Common/Extensions.cs	(revision 11741)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Common/Extensions.cs	(revision 11742)
@@ -8,5 +8,5 @@
   public static class Extensions {
     public static bool IsAlmost(this double x, double y) {
-      return Math.Abs(x - y) < 1.0e-6;
+      return Math.Abs(x - y) < 1.0e-12;
     }
 
@@ -38,9 +38,14 @@
       var ssX = 0.0;
       var ssY = 0.0;
-      foreach (var p in xs.Zip(ys, (x, y) => new { x, y })) {
-        s += (p.x - meanX) * (p.y - meanY);
-        ssX += Math.Pow(p.x - meanX, 2);
-        ssY += Math.Pow(p.y - meanY, 2);
+      var xEnum = xs.GetEnumerator();
+      var yEnum = ys.GetEnumerator();
+      while (xEnum.MoveNext() & yEnum.MoveNext()) {
+        var x = xEnum.Current;
+        var y = yEnum.Current;
+        s += (x - meanX) * (y - meanY);
+        ssX += Math.Pow(x - meanX, 2);
+        ssY += Math.Pow(y - meanY, 2);
       }
+      if (xEnum.MoveNext() | yEnum.MoveNext()) throw new ArgumentException("lengths are not equal");
 
       if (s.IsAlmost(0)) return 0;
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization.SymbReg/SymbolicRegressionProblem.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization.SymbReg/SymbolicRegressionProblem.cs	(revision 11741)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization.SymbReg/SymbolicRegressionProblem.cs	(revision 11742)
@@ -74,5 +74,5 @@
 
     // right now only + and * is supported
-    public string Hash(string terminalPhrase) {
+    public string CanonicalRepresentation(string terminalPhrase) {
       return terminalPhrase;
       //var terms = terminalPhrase.Split('+');
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization.Test/TestBanditPolicies.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization.Test/TestBanditPolicies.cs	(revision 11741)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization.Test/TestBanditPolicies.cs	(revision 11742)
@@ -4,4 +4,5 @@
 using System.Globalization;
 using HeuristicLab.Algorithms.Bandits;
+using HeuristicLab.Algorithms.Bandits.BanditPolicies;
 using HeuristicLab.Algorithms.Bandits.Models;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
@@ -16,10 +17,8 @@
       var nArms = 20;
 
-      // Console.WriteLine("Threshold Ascent (20)"); TestPolicyGaussianUnknownVariance(randSeed, nArms, new ThresholdAscent(20, 0.01));
-      // Console.WriteLine("Threshold Ascent (100)"); TestPolicyGaussianUnknownVariance(randSeed, nArms, new ThresholdAscent(100, 0.01));
-      // Console.WriteLine("Threshold Ascent (500)"); TestPolicyGaussianUnknownVariance(randSeed, nArms, new ThresholdAscent(500, 0.01));
-      // Console.WriteLine("Threshold Ascent (1000)"); TestPolicyGaussianUnknownVariance(randSeed, nArms, new ThresholdAscent(1000, 0.01));
-      Console.WriteLine("Thompson (Gaussian fixed variance)"); TestPolicyGaussianUnknownVariance(randSeed, nArms, new GenericThompsonSamplingPolicy(new GaussianModel(0, 1, 1)));
-      Console.WriteLine("Thompson (Gaussian est variance)"); TestPolicyGaussianUnknownVariance(randSeed, nArms, new GenericThompsonSamplingPolicy(new GaussianModel(0, 1, 1, 0.1)));
+      // ThresholdAscent only works for rewards in [0..1] so far
+
+      Console.WriteLine("Thompson (Gaussian est variance)"); TestPolicyGaussianUnknownVariance(randSeed, nArms, new GenericThompsonSamplingPolicy(new GaussianModel(0, 1, 1, 1)));
+      Console.WriteLine("Thompson (Gaussian fixed variance)"); TestPolicyGaussianUnknownVariance(randSeed, nArms, new GenericThompsonSamplingPolicy(new GaussianModel(0, 1, 0.1)));
       Console.WriteLine("GaussianThompson (compat)"); TestPolicyGaussianUnknownVariance(randSeed, nArms, new GaussianThompsonSamplingPolicy(true));
       Console.WriteLine("GaussianThompson"); TestPolicyGaussianUnknownVariance(randSeed, nArms, new GaussianThompsonSamplingPolicy());
@@ -91,7 +90,13 @@
       var randSeed = 31415;
       var nArms = 20;
+      Console.WriteLine("Threshold Ascent (20)"); TestPolicyGaussian(randSeed, nArms, new ThresholdAscentPolicy(20, 0.01));
+      Console.WriteLine("Threshold Ascent (100)"); TestPolicyGaussian(randSeed, nArms, new ThresholdAscentPolicy(100, 0.01));
+      Console.WriteLine("Threshold Ascent (500)"); TestPolicyGaussian(randSeed, nArms, new ThresholdAscentPolicy(500, 0.01));
+      Console.WriteLine("Threshold Ascent (1000)"); TestPolicyGaussian(randSeed, nArms, new ThresholdAscentPolicy(1000, 0.01));
+      Console.WriteLine("Generic Thompson (Gaussian fixed var)"); TestPolicyGaussian(randSeed, nArms, new GenericThompsonSamplingPolicy(new GaussianModel(0.5, 1)));
+      Console.WriteLine("Generic Thompson (Gaussian unknown var)"); TestPolicyGaussian(randSeed, nArms, new GenericThompsonSamplingPolicy(new GaussianModel(0.5, 1, 1, 1)));
       Console.WriteLine("Thompson (Gaussian orig)"); TestPolicyGaussian(randSeed, nArms, new GaussianThompsonSamplingPolicy(true));
       Console.WriteLine("Thompson (Gaussian new)"); TestPolicyGaussian(randSeed, nArms, new GaussianThompsonSamplingPolicy());
-      Console.WriteLine("Generic Thompson (Gaussian)"); TestPolicyGaussian(randSeed, nArms, new GenericThompsonSamplingPolicy(new GaussianModel(0.5, 1)));
+
       /*
       Console.WriteLine("Random"); TestPolicyNormal(randSeed, nArms, new RandomPolicy(new Random(seedForPolicy), nArms));
@@ -123,5 +128,5 @@
       Console.WriteLine("ChernoffIntervalEstimationPolicy(0.01)"); TestPolicyNormal(randSeed, nArms, new ChernoffIntervalEstimationPolicy(nArms, 0.01));
       Console.WriteLine("ChernoffIntervalEstimationPolicy(0.05)"); TestPolicyNormal(randSeed, nArms, new ChernoffIntervalEstimationPolicy(nArms, 0.05));
-      Console.WriteLine("ChernoffIntervalEstimationPolicy(0.1) "); TestPolicyNormal(randSeed, nArms, new ChernoffIntervalEstimationPolicy(nArms, 0.1));
+      Console.WriteLine("ChernoffIntervalEstimationPolicy(0.1) "); TestPolicyNormal(randSeed, nArms, new ChernoffIntervalEstimationPolicy(nArms, 0.1));      
       Console.WriteLine("ThresholdAscent(10,0.01)  "); TestPolicyNormal(randSeed, nArms, new ThresholdAscentPolicy(nArms, 10, 0.01));
       Console.WriteLine("ThresholdAscent(10,0.05)  "); TestPolicyNormal(randSeed, nArms, new ThresholdAscentPolicy(nArms, 10, 0.05));
@@ -141,7 +146,12 @@
       var randSeed = 31415;
       var nArms = 20;
+      Console.WriteLine("Threshold Ascent (20)"); TestPolicyGaussianMixture(randSeed, nArms, new ThresholdAscentPolicy(20, 0.01));
+      Console.WriteLine("Threshold Ascent (100)"); TestPolicyGaussianMixture(randSeed, nArms, new ThresholdAscentPolicy(100, 0.01));
+      Console.WriteLine("Threshold Ascent (500)"); TestPolicyGaussianMixture(randSeed, nArms, new ThresholdAscentPolicy(500, 0.01));
+      Console.WriteLine("Threshold Ascent (1000)"); TestPolicyGaussianMixture(randSeed, nArms, new ThresholdAscentPolicy(1000, 0.01));
       Console.WriteLine("Thompson (Gaussian orig)"); TestPolicyGaussianMixture(randSeed, nArms, new GaussianThompsonSamplingPolicy(true));
       Console.WriteLine("Thompson (Gaussian new)"); TestPolicyGaussianMixture(randSeed, nArms, new GaussianThompsonSamplingPolicy());
-      Console.WriteLine("Generic Thompson (Gaussian)"); TestPolicyGaussianMixture(randSeed, nArms, new GenericThompsonSamplingPolicy(new GaussianModel(0.5, 1)));
+      Console.WriteLine("Generic Thompson (Gaussian fixed variance)"); TestPolicyGaussianMixture(randSeed, nArms, new GenericThompsonSamplingPolicy(new GaussianModel(0.5, 1, 0.1)));
+      Console.WriteLine("Generic Thompson (Gaussian unknown variance)"); TestPolicyGaussianMixture(randSeed, nArms, new GenericThompsonSamplingPolicy(new GaussianModel(0.5, 1, 1, 1)));
 
       /*
@@ -167,19 +177,19 @@
 
 
-    private void TestPolicyBernoulli(int randSeed, int nArms, IPolicy policy) {
+    private void TestPolicyBernoulli(int randSeed, int nArms, IBanditPolicy policy) {
       TestPolicy(randSeed, nArms, policy, (banditRandom, nActions) => new BernoulliBandit(banditRandom, nActions));
     }
-    private void TestPolicyGaussian(int randSeed, int nArms, IPolicy policy) {
+    private void TestPolicyGaussian(int randSeed, int nArms, IBanditPolicy policy) {
       TestPolicy(randSeed, nArms, policy, (banditRandom, nActions) => new TruncatedNormalBandit(banditRandom, nActions));
     }
-    private void TestPolicyGaussianMixture(int randSeed, int nArms, IPolicy policy) {
+    private void TestPolicyGaussianMixture(int randSeed, int nArms, IBanditPolicy policy) {
       TestPolicy(randSeed, nArms, policy, (banditRandom, nActions) => new GaussianMixtureBandit(banditRandom, nActions));
     }
-    private void TestPolicyGaussianUnknownVariance(int randSeed, int nArms, IPolicy policy) {
+    private void TestPolicyGaussianUnknownVariance(int randSeed, int nArms, IBanditPolicy policy) {
       TestPolicy(randSeed, nArms, policy, (banditRandom, nActions) => new GaussianBandit(banditRandom, nActions));
     }
 
 
-    private void TestPolicy(int randSeed, int nArms, IPolicy policy, Func<Random, int, IBandit> banditFactory) {
+    private void TestPolicy(int randSeed, int nArms, IBanditPolicy policy, Func<Random, int, IBandit> banditFactory) {
       var maxIt = 1E5;
       var reps = 10; // independent runs
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/EvenParityProblem.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/EvenParityProblem.cs	(revision 11741)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/EvenParityProblem.cs	(revision 11742)
@@ -51,5 +51,5 @@
     }
 
-    public string Hash(string terminalPhrase) {
+    public string CanonicalRepresentation(string terminalPhrase) {
       return terminalPhrase;
     }
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/HardPalindromeProblem.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/HardPalindromeProblem.cs	(revision 11741)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/HardPalindromeProblem.cs	(revision 11742)
@@ -39,5 +39,5 @@
     }
 
-    public string Hash(string terminalPhrase) {
+    public string CanonicalRepresentation(string terminalPhrase) {
       return terminalPhrase;
     }
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/IProblem.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/IProblem.cs	(revision 11741)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/IProblem.cs	(revision 11742)
@@ -9,5 +9,5 @@
     IGrammar Grammar { get; }
     double Evaluate(string sentence);
-    string Hash(string terminalPhrase);
+    string CanonicalRepresentation(string terminalPhrase);
   }
 }
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/PalindromeProblem.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/PalindromeProblem.cs	(revision 11741)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/PalindromeProblem.cs	(revision 11742)
@@ -80,5 +80,5 @@
     }
 
-    public string Hash(string terminalPhrase) {
+    public string CanonicalRepresentation(string terminalPhrase) {
       return terminalPhrase;
     }
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/ReadonlySequence.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/ReadonlySequence.cs	(revision 11741)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/ReadonlySequence.cs	(revision 11742)
@@ -4,13 +4,13 @@
   public class ReadonlySequence : Sequence {
     public ReadonlySequence(string s)
-      : base(s) {
+      : base(s, s.Length) {
     }
 
     public ReadonlySequence(char ch)
-      : base(ch) {
+      : base(ch, 1) {
     }
 
     public ReadonlySequence(Sequence s)
-      : base(s) {
+      : base(s, s.Length) {
     }
 
@@ -32,5 +32,7 @@
     public override int GetHashCode() {
       int h = 31 * Length;
-      foreach (var ch in this) { h += 31 * (byte)h; }
+      for (int i = 0; i < Length; i++) {
+        h += 31 * (byte)this[i];
+      }
       return h;
     }
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/RoyalPairProblem.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/RoyalPairProblem.cs	(revision 11741)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/RoyalPairProblem.cs	(revision 11742)
@@ -34,5 +34,5 @@
     }
 
-    public string Hash(string terminalPhrase) {
+    public string CanonicalRepresentation(string terminalPhrase) {
       return terminalPhrase;
     }
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/RoyalRoadProblem.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/RoyalRoadProblem.cs	(revision 11741)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/RoyalRoadProblem.cs	(revision 11742)
@@ -29,5 +29,5 @@
       throw new NotImplementedException();
     }
-    public string Hash(string terminalPhrase) {
+    public string CanonicalRepresentation(string terminalPhrase) {
       return terminalPhrase;
     }
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/RoyalSymbolProblem.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/RoyalSymbolProblem.cs	(revision 11741)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/RoyalSymbolProblem.cs	(revision 11742)
@@ -33,5 +33,5 @@
       return regex.Matches(sentence).Count;
     }
-    public string Hash(string terminalPhrase) {
+    public string CanonicalRepresentation(string terminalPhrase) {
       return terminalPhrase;
     }
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/RoyalTreeProblem.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/RoyalTreeProblem.cs	(revision 11741)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/RoyalTreeProblem.cs	(revision 11742)
@@ -29,5 +29,5 @@
       throw new NotImplementedException();
     }
-    public string Hash(string terminalPhrase) {
+    public string CanonicalRepresentation(string terminalPhrase) {
       return terminalPhrase;
     }
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/SantaFeAntProblem.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/SantaFeAntProblem.cs	(revision 11741)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/SantaFeAntProblem.cs	(revision 11742)
@@ -98,5 +98,5 @@
     }
 
-    public string Hash(string terminalPhrase) {
+    public string CanonicalRepresentation(string terminalPhrase) {
       return terminalPhrase.Replace("rl", "").Replace("lr", "");
     }
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/Sequence.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/Sequence.cs	(revision 11741)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/Sequence.cs	(revision 11742)
@@ -46,11 +46,15 @@
     }
 
-    private Sequence() {
-      this.symbols = new char[maxIdx + 1];
+    private Sequence(int maxLength) {
+      this.symbols = new char[maxLength];
     }
 
     // create a sequence from a character
     public Sequence(char ch)
-      : this() {
+      : this(ch, maxIdx + 1) {
+    }
+
+    protected Sequence(char ch, int maxLength)
+      : this(maxLength) {
       this.len = 1;
       symbols[0] = ch;
@@ -61,6 +65,7 @@
 
     // create a sequence from a string
-    public Sequence(string s)
-      : this() {
+    public Sequence(string s) : this(s, maxIdx + 1) { }
+    protected Sequence(string s, int maxLength)
+      : this(maxLength) {
       if (string.IsNullOrEmpty(s)) throw new ArgumentException();
       if (s.Length > (maxIdx + 1)) throw new ArgumentException();
@@ -77,6 +82,7 @@
 
     // cloning ctor
-    public Sequence(Sequence original)
-      : this() {
+    public Sequence(Sequence original) : this(original, maxIdx + 1) { }
+    protected Sequence(Sequence original, int maxLength)
+      : this(maxLength) {
       this.len = original.len;
       Array.Copy(original.symbols, this.symbols, len);
@@ -128,5 +134,5 @@
       if (startIdx >= this.len) throw new ArgumentException();
       if (startIdx + len > this.len) throw new ArgumentException();
-      var subsequence = new Sequence { len = len };
+      var subsequence = new Sequence(maxIdx + 1) { len = len };
 
       Array.Copy(this.symbols, startIdx, subsequence.symbols, 0, len);
